<template>
<v-app class="bg">
    <v-container class="font">
        <v-row justify="space-between">
            <v-col cols="12" md="8">
                <v-card elevation="2">
                    <v-card-title class="headline">
                        รายการในรถเข็น
                    </v-card-title>
                    <v-divider></v-divider>
                    <v-card-text>
                        <v-simple-table>
                            <thead>
                                <tr>
                                    <th class="text-center" style="font-size: 16px;">รูปภาพ</th>
                                    <th class="text-center" style="font-size: 16px;">ชื่อสินค้า</th>
                                    <th class="text-center" style="font-size: 16px;">ราคา (บาท)</th>
                                    <th class="text-center" style="font-size: 16px;">จำนวน</th>
                                    <th class="text-center"></th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr v-for="item in cartItems" :key="item.productId">
                                    <td class="text-center">
                                        <div v-if="item.img">
                                            <v-img :src="item.img" max-height="150" max-width="150" contain></v-img>
                                        </div>
                                        <div v-else style="height: 150px; width: 150px; display: flex; align-items: center; justify-content: center; background-color: lightgray;">
                                            <span>Image not available</span>
                                        </div>
                                    </td>
                                    <td class="text-center">{{ item.productName }}</td>
                                    <td class="text-center">{{ item.price }}</td>
                                    <td class="text-center">
                                        <v-row align="center" justify="center" no-gutters>
                                            <v-col cols="auto">
                                                <v-btn @click="decreaseQuantity(item.productId)" small>
                                                    <v-icon color="green">mdi-minus-circle</v-icon>
                                                </v-btn>
                                                <span>{{ item.quantity }}</span>
                                                <v-btn @click="increaseQuantity(item.productId)" small>
                                                    <v-icon color="green">mdi-plus-circle</v-icon>
                                                </v-btn>
                                            </v-col>
                                        </v-row>
                                    </td>
                                    <td class="text-center">
                                        <v-btn @click="removeItem(item.productId)" small>
                                            <v-icon color="red">mdi-delete</v-icon>
                                        </v-btn>
                                    </td>
                                </tr>
                            </tbody>
                        </v-simple-table>
                    </v-card-text>
                    <v-divider />
                    <v-row>
                        <v-col class="text-start">
                            <v-btn @click="goHome()" text>
                                <v-icon elevation="2" fab>mdi-arrow-left</v-icon>กลับไปยังหน้า Shop
                            </v-btn>
                        </v-col>
                    </v-row>
                </v-card>
            </v-col>

            <v-col cols="12" md="4">
                <v-card elevation="2">
                    <v-card-title class="headline">
                        ชำระเงิน
                    </v-card-title>
                    <v-divider></v-divider>
                    <v-card-text>
                        <v-row>
                            <v-col class="text-right">
                                <v-subheader class="price-container">
                                    <span class="left-align">ราคา:</span>
                                    <span class="right-align">{{ totalPrice }} บาท</span>
                                </v-subheader>
                                <v-divider />
                                <v-subheader class="price-container">
                                    <span class="left-align">ส่วนลด:</span>
                                    <span class="right-align">0 บาท</span>
                                </v-subheader>
                                <v-divider />
                                <v-subheader class="price-container">
                                    <span class="left-align">ค่าจัดส่ง:</span>
                                    <span class="right-align">ฟรี</span>
                                </v-subheader>
                                <v-divider />
                                <v-subheader class="price-container">
                                    <span class="left-align"><b>รวม:</b></span>
                                    <span class="right-align"><b>{{ totalPrice }} บาท</b></span>
                                </v-subheader>
                            </v-col>
                        </v-row>
                    </v-card-text>
                    <v-divider></v-divider>
                    <v-card-actions style="justify-content: center;" align="center">
                        <v-btn color="primary" @click="checkout()">
                            ยืนยันคำสั่งซื้อ
                        </v-btn>
                    </v-card-actions>
                </v-card>
                <div>
                    <v-dialog v-model="toggle" max-width="500">
                        <v-card>
                            <v-card-title style="justify-content: center;">
                                สแกนคิวอาร์โค้ด
                            </v-card-title>
                            <div>
                                <v-img :src="`${qrBase64}`"></v-img>
                                <!-- <v-img src="../assets/qrcode.png"></v-img> -->
                                <div style="display: flex; justify-content: space-around; padding: 10px;">
                                    <v-btn color="success" @click="paymentss()">
                                        ชำระเงินแล้ว
                                    </v-btn>
                                    <v-btn color="error" @click="paymentcc()">
                                        ยกเลิก
                                    </v-btn>
                                </div>
                            </div>
                        </v-card>
                    </v-dialog>
                </div>
            </v-col>
        </v-row>
    </v-container>
</v-app>
</template>

<script>
import axios from 'axios';
import Swal from 'sweetalert2';
import Cookies from 'js-cookie';
import {
    jwtDecode
} from "jwt-decode";

export default {
    data() {
        return {
            token: Cookies.get('token'),
            cartItems: [],
            detail: [],
            qrBase64: "",
            toggle: false,
            orderid: "",
            loginId: ''
        };
    },
    mounted() {
        this.getuser();
        this.fetchCartItems();
    },
    computed: {
        totalPrice() {
            return this.cartItems.reduce((total, item) => {
                return total + (item.price || 0) * (item.quantity || 0);
            }, 0);
        },
    },
    methods: {
        async getuser() {
            if (this.token) {
                try {
                    const decoded = jwtDecode(this.token);
                    this.firstName = decoded.firstName;
                    this.loginId = decoded._id;
                    // console.log(this.firstName);
                    // console.log(this.loginId);
                } catch (error) {
                    Swal.fire({
                        position: "center",
                        icon: "error",
                        title: "Session Expired",
                        showConfirmButton: false,
                        timer: 3000
                    });
                    this.$router.push('/Homepage');
                }
            } else {
                Swal.fire({
                    position: "center",
                    icon: "error",
                    title: "Time Out",
                    showConfirmButton: false,
                    timer: 3000
                });
                this.$router.push('/Homepage');
            }
        },
        async payment() {
            let product2 = [];
            this.cartItems.map((carts) => {
                product2.push({
                    product: carts.productId,
                    quantity: carts.quantity
                });
                console.log(carts.productId);
            });
            const payload = {
                products: product2
            };
            console.log(product2);
            console.log(payload);

            try {
                const response = await axios.post(`http://192.168.73.121:3000/orders/${this.loginId}/create`, payload, {
                    headers: {
                        Authorization: `Bearer ${this.token}`
                    }
                });
                console.log(response.data.data.qrPayment);
                this.qrBase64 = response.data.data.qrPayment;
                console.log(response.data);

                const orderId = response.data.data.idOrder;
                console.log(orderId);

                this.orderid = orderId;

            } catch (error) {
                console.error('There was an error making the request:', error);
            }
        },
        async fetchCartItems() {
            try {
                const response = await axios.get(`http://192.168.73.121:3000/cart/${this.loginId}`, {
                    headers: {
                        Authorization: `Bearer ${this.token}`
                    }
                });
                this.cartItems = response.data.data.products;
                console.log(this.cartItems);
            } catch (error) {
                console.error('Error fetching cart items:', error);
            }
        },
        async increaseQuantity(productId) {
            try {
                const item = this.cartItems.find(item => item.productId === productId);
                if (item) {
                    const productResponse = await axios.get(`http://192.168.73.121:3000/products/${productId}`);
                    const product = productResponse.data.data;

                    if (item.quantity < product.amount) {
                        item.quantity++;
                        await axios.post(`http://192.168.73.121:3000/cart/${this.loginId}/add`, {
                            productId,
                            quantity: 1
                        });
                    } else {
                        alert('Quantity exceeds available stock');
                    }
                }
            } catch (error) {
                console.error('Error increasing quantity:', error);
            }
        },
        async decreaseQuantity(productId) {
            try {
                const item = this.cartItems.find(item => item.productId === productId);
                if (item && item.quantity > 1) {
                    item.quantity--;
                    await axios.post(`http://192.168.73.121:3000/cart/${this.loginId}/add`, {
                        productId,
                        quantity: -1
                    });
                }
            } catch (error) {
                console.error('Error decreasing quantity:', error);
            }
        },
        async removeItem(productId) {
            try {
                this.cartItems = this.cartItems.filter(item => item.productId !== productId);
                await axios.delete(`http://192.168.73.121:3000/cart//${this.loginId}/remove/${productId}`);
            } catch (error) {
                console.error('Error removing item:', error);
            }
        },
        async checkout() {
            this.toggle = !this.toggle
            this.payment()
        },
        goHome() {
            this.$router.push('/homepage');
        },
        async paymentss() {
            try {
                const response = await axios.post('http://192.168.75.212:3000/orders/payment/confrim');
                console.log(response.data);
                Swal.fire({
                    title: "ชำระเงินสำเร็จ",
                    text: "ได้รับออร์เดอร์ของคุณแล้ว",
                    icon: "success"
                });
            } catch (error) {
                console.error('There was an error making the request:', error);
            }
        },
        paymentcc() {
            location.reload();
        },
    }
};
</script>

<style scoped>
@import url("https://fonts.googleapis.com/css2?family=Prompt:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900&display=swap");

.font {
    font-family: "Prompt", sans-serif;
}

.headline {
    font-weight: bold;
    font-size: 24px;
}

.price-container {
    display: flex;
    justify-content: space-between;
}

.left-align {
    text-align: left;
}

.right-align {
    text-align: right;
}
</style>
